;Alternative Plus4-startable player for natural playcodes including subtunes
;(The original runnables in HVTC-player had multi-keypress music selection that doesn't fit the cRTED playback scheme.)

Year = 2023
BASIC_START = $1001
PLAYER_ADDRESS = $1500
DEFAULT_SUBTUNE = 0
INIT_ADDRESS = PLAYER_ADDRESS + 0
PLAY_ADDRESS = PLAYER_ADDRESS + 3
PLAYER_ENDADDRESS = PLAYER_ADDRESS + SOURCE_SIZE
SUBTUNE_AMOUNT = 4


        *=BASIC_START
        .word ss,Year
        .null $9e,format("%d",start) ;SYS command
ss      .word 0


start       sei
            sta $ff3f ;ROM off, RAM in

            ldy #40-1
-           lda authortext,y
            sta $0C00+0,y
            lda helptext,y
            sta $0C00+40,y
            dey
            bpl -

copytune    lda #<SOURCE_ENDADDRESS
            ldx #>SOURCE_ENDADDRESS
            sta $02
            stx $03
            lda #<PLAYER_ENDADDRESS
            ldx #>PLAYER_ENDADDRESS
            sta $04
            stx $05
copyloopH   ldy #0
copyloopL   lda ($02),y
            sta ($04),y
            iny
            bne copyloopL
            dec $03
            dec $05
            lda $03
            cmp #(>SOURCE_ADDRESS)-1
            bne copyloopH

inittune1   lda #DEFAULT_SUBTUNE
inittune    pha
-           lda #$00
            sta $FF11
            jsr keyrequest
            cmp #$FF
            bne -
            pla
            jsr INIT_ADDRESS

playloop    lda #$80
            cmp $FF1D
            bne *-3
            inc $FF15
            jsr PLAY_ADDRESS
            dec $FF15

keycheck    ldx #7
            lda #$7F
            sta $02
keychkloop  lda $02
            jsr keyrequest
            cmp #$FE
            bne +
            lda subtunenum,x
            jmp selecttune
+           cmp #$F7
            bne nextkeyrow
            lda subtunenum,x
            clc
            adc #1
selecttune  cmp #SUBTUNE_AMOUNT
            bcs playloop
            jmp inittune
nextkeyrow  sec
            ror $02
            dex
            bne keychkloop
            jmp playloop

keyrequest  sta $FD30
            sta $FF08
            lda $FF08
            rts

.enc screen
authortext .text "   ADVENTURE PARK BY CSABO/LOD (2019)   "
helptext .text "   PRESS KEYS 1..",format("%d",SUBTUNE_AMOUNT)," TO START SUBTUNES.   "
.enc none
subtunenum  .byte 10, 2, 4, 6, 8, 10, 10, 0


SOURCE_ADDRESS
.binary "adventure_park-natural.prg",2
SOURCE_ENDADDRESS
SOURCE_SIZE = SOURCE_ENDADDRESS-SOURCE_ADDRESS
