;Alternative Plus4-startable player for natural playcodes including subtunes
;(The original runnables in HVTC-player had multi-keypress music selection that doesn't fit the cRTED playback scheme.)

Year = 2023
BASIC_START = $1001
PLAYER_ADDRESS = $A000
DEFAULT_SUBTUNE = 0
INIT_ADDRESS = PLAYER_ADDRESS + 0
PLAY_ADDRESS = PLAYER_ADDRESS + 3
MULTISPEED_PLAY_ADDRESS = PLAYER_ADDRESS + 6
PLAYER_ENDADDRESS = PLAYER_ADDRESS + SOURCE_SIZE
SUBTUNE_AMOUNT = 7
sourceptr = $02
targetptr = $04

        *=BASIC_START
        .word ss,Year
        .null $9e,format("%d",start) ;SYS command
ss      .word 0


start       sei
            sta $ff3f ;ROM off, RAM in

            ldy #40-1
-           lda authortext,y
            sta $0C00+0,y
            lda helptext,y
            sta $0C00+40,y
            dey
            bpl -

copytune    lda #<SOURCE_ENDADDRESS-$100
            ldx #>SOURCE_ENDADDRESS-$100
            sta sourceptr+0
            stx sourceptr+1
            lda #<PLAYER_ENDADDRESS-$100
            ldx #>PLAYER_ENDADDRESS-$100
            sta targetptr+0
            stx targetptr+1
copyloopH   ldy #0
copyloopL   lda (sourceptr),y
            sta (targetptr),y
            iny
            bne copyloopL
            dec sourceptr+1
            dec targetptr+1
            lda sourceptr+1
            cmp #(>SOURCE_ADDRESS)-2
            bne copyloopH

inittune    lda #$00
            sta $FF11
            jsr keyrequest
            cmp #$FF
            bne -
subtune     lda #DEFAULT_SUBTUNE ;selfmod
            tax
            jsr INIT_ADDRESS

playloop    lda #$40
            cmp $FF1D
            bne *-3
            inc $FF19
            jsr PLAY_ADDRESS
            dec $FF19

keycheck    ldx #7
            lda #$7F
            sta $02
keychkloop  lda $02
            jsr keyrequest
            cmp #$FE
            bne +
            lda subtunenum,x
            jmp selecttune
+           cmp #$F7
            bne nextkeyrow
            lda subtunenum,x
            clc
            adc #1
selecttune  cmp #SUBTUNE_AMOUNT
            bcs multiplay
            sta subtune+1
            jmp copytune ;inittune
nextkeyrow  sec
            ror $02
            dex
            bne keychkloop
            jmp multiplay

keyrequest  sta $FD30
            sta $FF08
            lda $FF08
            rts

multiplay   lda #$DC
            cmp $FF1D
            bne *-3
            inc $FF19
            jsr MULTISPEED_PLAY_ADDRESS
            dec $FF19
            jmp playloop

.enc screen
authortext .text "  SGT HELMET ZERO BY CSABO/LOD (2013)   "
helptext .text "   PRESS KEYS 1..",format("%d",SUBTUNE_AMOUNT)," TO START SUBTUNES.   "
.enc none
subtunenum  .byte 10, 2, 4, 6, 8, 10, 10, 0


SOURCE_ADDRESS
.binary "sgt_helmet_zero-natural.prg",2
SOURCE_ENDADDRESS
SOURCE_SIZE = SOURCE_ENDADDRESS-SOURCE_ADDRESS
