;Alternative Plus4-startable player for natural playcodes including subtunes
;(The original runnables in HVTC-player had multi-keypress music selection that doesn't fit the cRTED playback scheme.)

Year = 2023
BASIC_START = $1001
PLAYER_ADDRESS = $8000
INIT_ADDRESS = PLAYER_ADDRESS + 0
PLAY_ADDRESS = PLAYER_ADDRESS + 3
SUBTUNE_AMOUNT = 4


        *=BASIC_START
        .word ss,Year
        .null $9e,format("%d",start) ;SYS command
ss      .word 0


start       sei
            sta $ff3f ;ROM off, RAM in

            ldy #40-1
-           lda helptext,y
            sta $0C00,y
            dey
            bpl -

copytune    lda #<SOURCE_ADDRESS
            ldx #>SOURCE_ADDRESS
            sta $02
            stx $03
            lda #<PLAYER_ADDRESS
            ldx #>PLAYER_ADDRESS
            sta $04
            stx $05
copyloopH   ldy #0
copyloopL   lda ($02),y
            sta ($04),y
            iny
            bne copyloopL
            inc $03
            inc $05
            lda $03
            cmp #(>SOURCE_ENDADDRESS)+1
            bne copyloopH

inittune1   lda #$00
inittune    jsr INIT_ADDRESS

playloop    lda #$80
            cmp $FF1D
            bne *-3
            inc $FF15
            jsr PLAY_ADDRESS
            dec $FF15

keycheck    ldx #7
            lda #$7F
            sta $02
keychkloop  lda $02
            sta $FD30
            sta $FF08
            lda $FF08
            cmp #$FE
            bne +
            lda subtunenum,x
            jmp selecttune
+           cmp #$F7
            bne nextkeyrow
            lda subtunenum,x
            clc
            adc #1
selecttune  cmp #SUBTUNE_AMOUNT
            bcs playloop
            jmp inittune
nextkeyrow  sec
            ror $02
            dex
            bne keychkloop
            jmp playloop

.enc screen
helptext .text "   PRESS KEYS 1..",format("%d",SUBTUNE_AMOUNT)," TO START SUBTUNES.   "
.enc none
subtunenum  .byte 10, 2, 4, 6, 8, 10, 10, 0


SOURCE_ADDRESS
.binary "reaxion-natural.prg",2
SOURCE_ENDADDRESS
